SystemOrganization addCategory: #'Pier-CommandLink'!

PRInternalLink subclass: #PRButtonLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-CommandLink'!

!PRButtonLink class methodsFor: 'as yet unclassified' stamp: 'kph 10/30/2007 02:50'!
isValidReference: aString
	^ aString beginsWith: 'button:'! !

!PRButtonLink methodsFor: 'as yet unclassified' stamp: 'kph 10/30/2007 00:21'!
acceptLinkBroken: aVisitor
	^ aVisitor visitInternalButtonLinkBroken: self! !

!PRButtonLink methodsFor: 'as yet unclassified' stamp: 'kph 1/30/2008 23:39'!
acceptLinkEmbed: aVisitor
	^ aVisitor visitInternalLinkEmbed: self! !

!PRButtonLink methodsFor: 'as yet unclassified' stamp: 'kph 12/31/2007 01:00'!
acceptLinkGoto: aVisitor
 
	^ aVisitor visitInternalButtonLinkGoto: self! !

!PRButtonLink methodsFor: 'as yet unclassified' stamp: 'kph 12/31/2007 01:11'!
pageReference

	^ self reference copyAfter: $:! !

!PRButtonLink methodsFor: 'as yet unclassified' stamp: 'kph 12/31/2007 01:11'!
refresh
	"This message will be sent by the structure whenever it is parsed and the references have to be set up. It simply starts a look-up in the owner using the reference-string. In case the reference is invalid the target will be set to ==nil== and the receiver is in a broken-state."

	self target: (PRPathLookup
		start: self owner
		path: self pageReference
		onError: [ nil ])! !

PRInternalLink subclass: #PRCommandLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-CommandLink'!

!PRCommandLink class methodsFor: 'as yet unclassified' stamp: 'kph 8/11/2007 01:34'!
isValidReference: aString
	^ 'command:*' match: aString! !

!PRCommandLink class methodsFor: 'as yet unclassified' stamp: 'kph 8/11/2007 01:35'!
priority
	^ 20! !

!PRCommandLink methodsFor: 'as yet unclassified' stamp: 'kph 10/2/2007 11:50'!
accept: aVisitor

	aVisitor visitCommandLink: self! !

!PRCommandLink methodsFor: 'as yet unclassified' stamp: 'kph 8/11/2007 13:19'!
refresh
	"This message will be sent by the structure whenever it is parsed and the references have to be set up. It simply starts a look-up in the owner using the reference-string. In case the reference is invalid the target will be set to ==nil== and the receiver is in a broken-state."

	| theClassName |
	
	theClassName := self reference copyAfterLast: $:.
 
	self target: (Smalltalk at: theClassName asSymbol ifAbsent: [ nil ])
	 ! !

!PRCommandLink methodsFor: 'as yet unclassified' stamp: 'kph 10/2/2007 11:49'!
target
	"Answer the referenced structure."
	
	(target isNil and: [ self hasOwner ])
		ifTrue: [ self refresh ].
		
	target isObsolete ifTrue: [ target := target nonObsoleteClass ]. 
	^ target! !

!PRCommandLink methodsFor: 'as yet unclassified' stamp: 'kph 9/14/2007 03:20'!
title
	^ self target isNil
		ifTrue: [ super title ]
		ifFalse: [ self target label ]! !

!PRViewRenderer methodsFor: '*pier-commandlink-visiting-links' stamp: 'kph 8/11/2007 01:56'!
visitCommandLinkBroken: anObject
 
	html anchor
		class: 'broken';
		with: [ super visitCommandLinkBroken: anObject ]! !

!PRViewRenderer methodsFor: '*pier-commandlink-visiting-links' stamp: 'kph 8/11/2007 02:31'!
visitCommandLinkGoto: anObject
	|  context |
	
	(anObject target isValidIn: self context) ifFalse: [ ^ self ].
	 
	context := self context
		command: anObject target new.
		
 "fill in command params here?"		
	
	html anchor
		class: 'internal';
		title: anObject target shortLabel;
		goto: context;
		with: [ super visitCommandLinkGoto: anObject ]
		! !

!PRViewRenderer methodsFor: '*pier-commandlink-visiting-links' stamp: 'kph 10/30/2007 03:25'!
visitInternalButtonLinkBroken: anObject
 
	| lookup context |
	lookup := PRIncompletePathLookup
		start: self context structure
		path: anObject reference.
	context := self context
		structure: lookup key
		command: PRAddCommand new.
	context command
		name: lookup value;
		link: anObject.
	html button
		class: 'broken';
		title: anObject title;
		goto: context;
		with: [ super visitInternalLinkGoto: anObject ]! !

!PRViewRenderer methodsFor: '*pier-commandlink-visiting-links' stamp: 'kph 10/30/2007 04:29'!
visitInternalButtonLinkGoto: anObject
	html form
	with: [ html button
		class: 'internal';
		title: anObject title;
		goto: (self context structure: anObject target);
		with: [ super visitInternalLinkGoto: anObject ] ]! !

!PRVisitor methodsFor: '*pier-commandlink-visiting-document' stamp: 'kph 8/11/2007 02:17'!
visitCommandLink: anObject
	self visitLink: anObject! !

!WAButtonTag methodsFor: '*pier-commandlink' stamp: 'kph 10/30/2007 03:20'!
goto: aContext
	"Initialize the receiver to properly activate aContext when being clicked. This includes a callback and a human-readable and bookmarkable url."

	aContext isValid
		ifFalse: [ ^ self class: 'protected'; disabled: true ].
	aContext command isConfirmed
		ifTrue: [ self onClick: 'return confirm(''Are you sure to perform the selected action: ' , aContext command name , '?'')' ].
	self callback: [ PRCurrentContext value: aContext ].
	self class: aContext structure cssClass! !

!PRDeepRenderer methodsFor: '*pier-commandlink-visiting-links' stamp: 'kph 8/11/2007 01:52'!
visitCommandLink: anObject
	anObject isBroken
		ifTrue: [ ^ self visitCommandLinkBroken: anObject ].
	(anObject isEmbedded not or: [ self doesRemember: anObject target ])
		ifTrue: [ ^ self visitCommandLinkGoto: anObject ].
	self
		remember: anObject target
		while: [ self visitCommandLinkEmbed: anObject ]! !

!PRDeepRenderer methodsFor: '*pier-commandlink-visiting-links' stamp: 'kph 8/11/2007 01:53'!
visitCommandLinkBroken: anObject
	self visitLink: anObject! !

!PRDeepRenderer methodsFor: '*pier-commandlink-visiting-links' stamp: 'kph 8/11/2007 02:36'!
visitCommandLinkGoto: anObject
 
	anObject hasAlias
		ifTrue: [ super visitLink: anObject ]
		ifFalse: [ html render: anObject target shortLabel ]! !
